<?php
if($status == 'admin' && (basename(SELF) == 'editor.php' || basename(SELF) == 'module.php')){

	$AISStorage = new EngineStorage('module.autoindexsearch');
	$autoIndexSearch = $AISStorage->iss('autoIndexSearch')?$AISStorage->get('autoIndexSearch'):1;

	if($autoIndexSearch){
		$setIndexSearch = false;
		if(basename(SELF) == 'editor.php' && isset($_POST['new_cfg_id_page']) && isset($_POST['new_cfg_name']) && isset($_POST['new_cfg_keywords']) && isset($_POST['new_cfg_description'])){
			$delluri = $Config->indexPage == $_POST['page']?'/':'/'.htmlspecialchars($_POST['page']);
			$uri = $Config->indexPage == $_POST['new_cfg_id_page']?'/':'/'.htmlspecialchars($_POST['new_cfg_id_page']);
			$name = htmlspecialchars($_POST['new_cfg_name']);
			$keywords = htmlspecialchars($_POST['new_cfg_keywords']);
			$description = htmlspecialchars($_POST['new_cfg_description']);
			
			$setIndexSearch = true;
		}
		if(basename(SELF) == 'module.php' && isset($_GET['module']) && $_GET['module'] == 'news' && isset($_POST['id']) && isset($_POST['header']) && isset($_POST['keywords']) && isset($_POST['description'])){
			$NewsStorage = new EngineStorage('module.news2');
			if($NewsStorage->iss('newsConfig')){
				$newsConfig = json_decode($NewsStorage->get('newsConfig'));
			}
			if(!isset($newsConfig->idPage)){$newsConfig->idPage = 'news';}
			
			$delluri = '/'.$newsConfig->idPage.'/'.htmlspecialchars($_POST['news']);
			$uri = '/'.$newsConfig->idPage.'/'.htmlspecialchars($_POST['id']);
			$name = htmlspecialchars($_POST['header']);
			$keywords = htmlspecialchars($_POST['keywords']);
			$description = htmlspecialchars($_POST['description']);
			
			$setIndexSearch = true;
		}

		if($setIndexSearch){
			
			$start_time = microtime();
			$start_array = explode(' ',$start_time);
			$start_time = $start_array[1] + $start_array[0];

			$SearchStorage = new EngineStorage('module.search');
			if($SearchStorage->iss('searchIndex1')){
				$searchIndex = json_decode($SearchStorage->get('searchIndex1'), true);
				foreach($searchIndex as $key => $value){
					if($value['uri'] == $delluri){
						unset($searchIndex[$key]);
					}
				}
			}else{
				$searchIndex = array();
			}
			$searchIndex[] = array('uri' => $uri, 'name' => $name, 'keywords' => $keywords, 'description' => $description);
			$searchIndex = array_values($searchIndex); // Переиндексировали числовые индексы 
			$SearchStorage->set('searchIndex1', json_encode($searchIndex));

			$end_time = microtime();
			$end_array = explode(" ",$end_time);
			$end_time = $end_array[1] + $end_array[0];
			$time = round($end_time - $start_time, 4);
			
			if($time >= 2){
				System::notification('Автоматически сформирован новый поисковой индекс за '.$time.' сек. Такое время генерации считается завышенным.', 'r');
			}else{
				System::notification('Автоматически сформирован новый поисковой индекс за '.$time.' сек.', 'g');
			}
			
		}
	}
}
?>